随笔 - 43  文章 - 0 评论 - 2 阅读 - 24869
< 2025年2月 >
26 27 28 29 30 31 1
2 3 4 5 6 7 8
9 10 11 12 13 14 15
16 17 18 19 20 21 22
23 24 25 26 27 28 1
2 3 4 5 6 7 8

Given a collection of candidate numbers (candidates) and a target number (target), find all unique combinations in candidates where the candidate numbers sums to target.

Each number in candidates may only be used once in the combination.

Note:

  • All numbers (including target) will be positive integers.
  • The solution set must not contain duplicate combinations.

Example 1:

Input: candidates = [10,1,2,7,6,1,5], target = 8,
A solution set is:
[
  [1, 7],
  [1, 2, 5],
  [2, 6],
  [1, 1, 6]
]

Example 2:

Input: candidates = [2,5,2,1,2], target = 5,
A solution set is:
[
  [1,2,2],
  [5]
]

 

LeetCode 39. Combination Sum —— 组合总和的升级版。还是想象成图来帮助理解。和第39题相比本题有两个变化。第一,本题有重复节点;第二,每个节点只能用一次,即没有自环。结合对39代码注释的理解,稍稍更改即可得到本题的解题思路:

如何处理自环问题?每次搜索新路径的时候都从其下一个节点开始,而不是从它本身开始;

如何处理去重问题?每次回溯的时候,刚刚被剔除的节点不能在任何时候再被重新加入到路径上。如何处理这个“任何时候”呢?要么用map标记被剔除的节点直到路径搜索结束,要么应用排序,将所有有相同出权值的节点都放到一起,这样可以方便找到下一个出权值不同的节点。

想完这两个不同点,这道题就解决了。详见代码注释。

 


Java

复制代码
class Solution {
    public List<List<Integer>> combinationSum2(int[] candidates, int target) {
        List<List<Integer>> res = new ArrayList<>();
        if (candidates == null || candidates.length == 0 || target < 0) return res;
        List<Integer> list = new ArrayList<>();
        Arrays.sort(candidates); //排序,使得寻找相同出权值的节点变得容易
        get(candidates, target, 0, list, res);
        return res;
    }
    
    private void get(int[] candidates, int target, int i, List<Integer> list, List<List<Integer>> res) {
        if (i > candidates.length || target < 0) return; //因为没有自环,所以每次都是从下一个节点开始搜索,要添加一个条件判断节点仍在图中
        if (target == 0) { //满足条件,添加至结果集
            res.add(new ArrayList<>(list)); 
            return;
        }
        for (int p = i; p < candidates.length; p++) { 
            list.add(candidates[p]); //添加节点到路径
            get(candidates, target - candidates[p], p+1, list, res); //因为没有自环,所以每次搜索更新路径权值后的下一个节点
            list.remove(list.size()-1); //回溯,将当前节点从路径中剔除
            while (p < candidates.length - 1 && candidates[p] == candidates[p+1]) p++; //因为存在重复节点,所以已经被剔除的节点不能再被放回到路径中
        }
    }
}
复制代码

 

posted on   小T在学习  阅读(1612)  评论(0编辑  收藏  举报
编辑推荐:
· [.NET]调用本地 Deepseek 模型
· 一个费力不讨好的项目,让我损失了近一半的绩效!
· .NET Core 托管堆内存泄露/CPU异常的常见思路
· PostgreSQL 和 SQL Server 在统计信息维护中的关键差异
· C++代码改造为UTF-8编码问题的总结
阅读排行:
· 一个费力不讨好的项目,让我损失了近一半的绩效!
· 清华大学推出第四讲使用 DeepSeek + DeepResearch 让科研像聊天一样简单!
· 实操Deepseek接入个人知识库
· CSnakes vs Python.NET:高效嵌入与灵活互通的跨语言方案对比
· Plotly.NET 一个为 .NET 打造的强大开源交互式图表库
点击右上角即可分享
微信分享提示